diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/applications/model/udp-echo-client.h ns-3.44/src/applications/model/udp-echo-client.h
--- ns-3.43/src/applications/model/udp-echo-client.h	2024-10-09 16:41:09.848655700 -0700
+++ ns-3.44/src/applications/model/udp-echo-client.h	2025-03-09 16:55:49.347370900 -0700
@@ -7,12 +7,16 @@
 #ifndef UDP_ECHO_CLIENT_H
 #define UDP_ECHO_CLIENT_H
 
-#include "ns3/application.h"
+#include "source-application.h"
+
+#include "ns3/deprecated.h"
 #include "ns3/event-id.h"
 #include "ns3/ipv4-address.h"
 #include "ns3/ptr.h"
 #include "ns3/traced-callback.h"
 
+#include <optional>
+
 namespace ns3
 {
 
@@ -20,58 +24,56 @@
 class Packet;
 
 /**
- * \ingroup udpecho
- * \brief A Udp Echo client
+ * @ingroup udpecho
+ * @brief A Udp Echo client
  *
  * Every packet sent should be returned by the server and received here.
  */
-class UdpEchoClient : public Application
+class UdpEchoClient : public SourceApplication
 {
   public:
     /**
-     * \brief Get the type ID.
-     * \return the object TypeId
+     * @brief Get the type ID.
+     * @return the object TypeId
      */
     static TypeId GetTypeId();
 
     UdpEchoClient();
-
     ~UdpEchoClient() override;
 
+    static constexpr uint16_t DEFAULT_PORT{0}; //!< default port
+
     /**
-     * \brief set the remote address and port
-     * \param ip remote IP address
-     * \param port remote port
-     */
-    void SetRemote(Address ip, uint16_t port);
-    /**
-     * \brief set the remote address
-     * \param addr remote address
+     * @brief set the remote address and port
+     * @param ip remote IP address
+     * @param port remote port
      */
-    void SetRemote(Address addr);
+    NS_DEPRECATED_3_44("Use SetRemote without port parameter instead")
+    void SetRemote(const Address& ip, uint16_t port);
+    void SetRemote(const Address& addr) override;
 
     /**
      * Set the data size of the packet (the number of bytes that are sent as data
      * to the server).  The contents of the data are set to unspecified (don't
      * care) by this call.
      *
-     * \warning If you have set the fill data for the echo client using one of the
+     * @warning If you have set the fill data for the echo client using one of the
      * SetFill calls, this will undo those effects.
      *
-     * \param dataSize The size of the echo data you want to sent.
+     * @param dataSize The size of the echo data you want to sent.
      */
     void SetDataSize(uint32_t dataSize);
 
     /**
      * Get the number of data bytes that will be sent to the server.
      *
-     * \warning The number of bytes may be modified by calling any one of the
+     * @warning The number of bytes may be modified by calling any one of the
      * SetFill methods.  If you have called SetFill, then the number of
      * data bytes will correspond to the size of an initialized data buffer.
      * If you have not called a SetFill method, the number of data bytes will
      * correspond to the number of don't care bytes that will be sent.
      *
-     * \returns The number of data bytes.
+     * @returns The number of data bytes.
      */
     uint32_t GetDataSize() const;
 
@@ -79,11 +81,11 @@
      * Set the data fill of the packet (what is sent as data to the server) to
      * the zero-terminated contents of the fill string string.
      *
-     * \warning The size of resulting echo packets will be automatically adjusted
+     * @warning The size of resulting echo packets will be automatically adjusted
      * to reflect the size of the fill string -- this means that the PacketSize
      * attribute may be changed as a result of this call.
      *
-     * \param fill The string to use as the actual echo data bytes.
+     * @param fill The string to use as the actual echo data bytes.
      */
     void SetFill(std::string fill);
 
@@ -92,12 +94,12 @@
      * the repeated contents of the fill byte.  i.e., the fill byte will be
      * used to initialize the contents of the data packet.
      *
-     * \warning The size of resulting echo packets will be automatically adjusted
+     * @warning The size of resulting echo packets will be automatically adjusted
      * to reflect the dataSize parameter -- this means that the PacketSize
      * attribute may be changed as a result of this call.
      *
-     * \param fill The byte to be repeated in constructing the packet data..
-     * \param dataSize The desired size of the resulting echo packet data.
+     * @param fill The byte to be repeated in constructing the packet data..
+     * @param dataSize The desired size of the resulting echo packet data.
      */
     void SetFill(uint8_t fill, uint32_t dataSize);
 
@@ -109,13 +111,13 @@
      * accomplished by setting the fillSize set to your desired dataSize
      * (and providing an appropriate buffer).
      *
-     * \warning The size of resulting echo packets will be automatically adjusted
+     * @warning The size of resulting echo packets will be automatically adjusted
      * to reflect the dataSize parameter -- this means that the PacketSize
      * attribute of the Application may be changed as a result of this call.
      *
-     * \param fill The fill pattern to use when constructing packets.
-     * \param fillSize The number of bytes in the provided fill pattern.
-     * \param dataSize The desired size of the final echo data.
+     * @param fill The fill pattern to use when constructing packets.
+     * @param fillSize The number of bytes in the provided fill pattern.
+     * @param dataSize The desired size of the final echo data.
      */
     void SetFill(uint8_t* fill, uint32_t fillSize, uint32_t dataSize);
 
@@ -124,21 +126,39 @@
     void StopApplication() override;
 
     /**
-     * \brief Schedule the next packet transmission
-     * \param dt time interval between packets.
+     * @brief Set the remote port (temporary function until deprecated attributes are removed)
+     * @param port remote port
+     */
+    void SetPort(uint16_t port);
+
+    /**
+     * @brief Get the remote port (temporary function until deprecated attributes are removed)
+     * @return the remote port
+     */
+    uint16_t GetPort() const;
+
+    /**
+     * @brief Get the remote address (temporary function until deprecated attributes are removed)
+     * @return the remote address
+     */
+    Address GetRemote() const;
+
+    /**
+     * @brief Schedule the next packet transmission
+     * @param dt time interval between packets.
      */
     void ScheduleTransmit(Time dt);
     /**
-     * \brief Send a packet
+     * @brief Send a packet
      */
     void Send();
 
     /**
-     * \brief Handle a packet reception.
+     * @brief Handle a packet reception.
      *
      * This function is called by lower layers.
      *
-     * \param socket the socket the packet was received to.
+     * @param socket the socket the packet was received to.
      */
     void HandleRead(Ptr<Socket> socket);
 
@@ -149,12 +169,10 @@
     uint32_t m_dataSize; //!< packet payload size (must be equal to m_size)
     uint8_t* m_data;     //!< packet payload data
 
-    uint32_t m_sent;       //!< Counter for sent packets
-    Ptr<Socket> m_socket;  //!< Socket
-    Address m_peerAddress; //!< Remote peer address
-    uint16_t m_peerPort;   //!< Remote peer port
-    uint8_t m_tos;         //!< The packets Type of Service
-    EventId m_sendEvent;   //!< Event to send the next packet
+    uint32_t m_sent;                    //!< Counter for sent packets
+    Ptr<Socket> m_socket;               //!< Socket
+    std::optional<uint16_t> m_peerPort; //!< Remote peer port (deprecated) // NS_DEPRECATED_3_44
+    EventId m_sendEvent;                //!< Event to send the next packet
 
     /// Callbacks for tracing the packet Tx events
     TracedCallback<Ptr<const Packet>> m_txTrace;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/applications/model/udp-echo-server.cc ns-3.44/src/applications/model/udp-echo-server.cc
--- ns-3.43/src/applications/model/udp-echo-server.cc	2024-10-09 16:41:09.848655700 -0700
+++ ns-3.44/src/applications/model/udp-echo-server.cc	2025-03-09 16:55:49.347370900 -0700
@@ -32,14 +32,9 @@
 {
     static TypeId tid =
         TypeId("ns3::UdpEchoServer")
-            .SetParent<Application>()
+            .SetParent<SinkApplication>()
             .SetGroupName("Applications")
             .AddConstructor<UdpEchoServer>()
-            .AddAttribute("Port",
-                          "Port on which we listen for incoming packets.",
-                          UintegerValue(9),
-                          MakeUintegerAccessor(&UdpEchoServer::m_port),
-                          MakeUintegerChecker<uint16_t>())
             .AddAttribute("Tos",
                           "The Type of Service used to send IPv4 packets. "
                           "All 8 bits of the TOS byte are set (including ECN bits).",
@@ -58,6 +53,9 @@
 }
 
 UdpEchoServer::UdpEchoServer()
+    : SinkApplication(DEFAULT_PORT),
+      m_socket{nullptr},
+      m_socket6{nullptr}
 {
     NS_LOG_FUNCTION(this);
 }
@@ -76,9 +74,13 @@
 
     if (!m_socket)
     {
-        TypeId tid = TypeId::LookupByName("ns3::UdpSocketFactory");
+        auto tid = TypeId::LookupByName("ns3::UdpSocketFactory");
         m_socket = Socket::CreateSocket(GetNode(), tid);
-        InetSocketAddress local = InetSocketAddress(Ipv4Address::GetAny(), m_port);
+        auto local = m_local;
+        if (local.IsInvalid())
+        {
+            local = InetSocketAddress(Ipv4Address::GetAny(), m_port);
+        }
         if (m_socket->Bind(local) == -1)
         {
             NS_FATAL_ERROR("Failed to bind socket");
@@ -96,35 +98,36 @@
                 NS_FATAL_ERROR("Error: Failed to join multicast group");
             }
         }
+        m_socket->SetIpTos(m_tos); // Affects only IPv4 sockets.
+        m_socket->SetRecvCallback(MakeCallback(&UdpEchoServer::HandleRead, this));
     }
 
-    if (!m_socket6)
+    if (m_local.IsInvalid() && !m_socket6)
     {
-        TypeId tid = TypeId::LookupByName("ns3::UdpSocketFactory");
+        // local address is not specified, so create another socket to also listen to all IPv6
+        // addresses
+        auto tid = TypeId::LookupByName("ns3::UdpSocketFactory");
         m_socket6 = Socket::CreateSocket(GetNode(), tid);
-        Inet6SocketAddress local6 = Inet6SocketAddress(Ipv6Address::GetAny(), m_port);
-        if (m_socket6->Bind(local6) == -1)
+        auto local = Inet6SocketAddress(Ipv6Address::GetAny(), m_port);
+        if (m_socket6->Bind(local) == -1)
         {
             NS_FATAL_ERROR("Failed to bind socket");
         }
-        if (addressUtils::IsMulticast(local6))
+        if (addressUtils::IsMulticast(local))
         {
             Ptr<UdpSocket> udpSocket = DynamicCast<UdpSocket>(m_socket6);
             if (udpSocket)
             {
                 // equivalent to setsockopt (MCAST_JOIN_GROUP)
-                udpSocket->MulticastJoinGroup(0, local6);
+                udpSocket->MulticastJoinGroup(0, local);
             }
             else
             {
                 NS_FATAL_ERROR("Error: Failed to join multicast group");
             }
         }
+        m_socket6->SetRecvCallback(MakeCallback(&UdpEchoServer::HandleRead, this));
     }
-
-    m_socket->SetIpTos(m_tos); // Affects only IPv4 sockets.
-    m_socket->SetRecvCallback(MakeCallback(&UdpEchoServer::HandleRead, this));
-    m_socket6->SetRecvCallback(MakeCallback(&UdpEchoServer::HandleRead, this));
 }
 
 void
@@ -149,11 +152,10 @@
 {
     NS_LOG_FUNCTION(this << socket);
 
-    Ptr<Packet> packet;
     Address from;
-    Address localAddress;
-    while ((packet = socket->RecvFrom(from)))
+    while (auto packet = socket->RecvFrom(from))
     {
+        Address localAddress;
         socket->GetSockName(localAddress);
         m_rxTrace(packet);
         m_rxTraceWithAddresses(packet, from, localAddress);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/applications/model/udp-echo-server.h ns-3.44/src/applications/model/udp-echo-server.h
--- ns-3.43/src/applications/model/udp-echo-server.h	2024-10-09 16:41:09.848655700 -0700
+++ ns-3.44/src/applications/model/udp-echo-server.h	2025-03-09 16:55:49.347370900 -0700
@@ -7,8 +7,8 @@
 #ifndef UDP_ECHO_SERVER_H
 #define UDP_ECHO_SERVER_H
 
-#include "ns3/address.h"
-#include "ns3/application.h"
+#include "sink-application.h"
+
 #include "ns3/event-id.h"
 #include "ns3/ptr.h"
 #include "ns3/traced-callback.h"
@@ -20,24 +20,27 @@
 class Packet;
 
 /**
- * \ingroup applications
- * \defgroup udpecho UdpEcho
+ * @ingroup applications
+ * @defgroup udpecho UdpEcho
  */
 
 /**
- * \ingroup udpecho
- * \brief A Udp Echo server
+ * @ingroup udpecho
+ * @brief A Udp Echo server
  *
  * Every packet received is sent back.
  */
-class UdpEchoServer : public Application
+class UdpEchoServer : public SinkApplication
 {
   public:
+    static constexpr uint16_t DEFAULT_PORT{9}; //!< default port
+
     /**
-     * \brief Get the type ID.
-     * \return the object TypeId
+     * @brief Get the type ID.
+     * @return the object TypeId
      */
     static TypeId GetTypeId();
+
     UdpEchoServer();
     ~UdpEchoServer() override;
 
@@ -46,19 +49,17 @@
     void StopApplication() override;
 
     /**
-     * \brief Handle a packet reception.
+     * @brief Handle a packet reception.
      *
      * This function is called by lower layers.
      *
-     * \param socket the socket the packet was received to.
+     * @param socket the socket the packet was received to.
      */
     void HandleRead(Ptr<Socket> socket);
 
-    uint16_t m_port;       //!< Port on which we listen for incoming packets.
     uint8_t m_tos;         //!< The packets Type of Service
-    Ptr<Socket> m_socket;  //!< IPv4 Socket
-    Ptr<Socket> m_socket6; //!< IPv6 Socket
-    Address m_local;       //!< local multicast address
+    Ptr<Socket> m_socket;  //!< Socket
+    Ptr<Socket> m_socket6; //!< IPv6 Socket (used if only port is specified)
 
     /// Callbacks for tracing the packet Rx events
     TracedCallback<Ptr<const Packet>> m_rxTrace;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/applications/model/udp-server.cc ns-3.44/src/applications/model/udp-server.cc
--- ns-3.43/src/applications/model/udp-server.cc	2024-10-09 16:41:09.848655700 -0700
+++ ns-3.44/src/applications/model/udp-server.cc	2025-03-09 16:55:49.347370900 -0700
@@ -35,20 +35,9 @@
 {
     static TypeId tid =
         TypeId("ns3::UdpServer")
-            .SetParent<Application>()
+            .SetParent<SinkApplication>()
             .SetGroupName("Applications")
             .AddConstructor<UdpServer>()
-            .AddAttribute("Port",
-                          "Port on which we listen for incoming packets.",
-                          UintegerValue(100),
-                          MakeUintegerAccessor(&UdpServer::m_port),
-                          MakeUintegerChecker<uint16_t>())
-            .AddAttribute("Tos",
-                          "The Type of Service used to send IPv4 packets. "
-                          "All 8 bits of the TOS byte are set (including ECN bits).",
-                          UintegerValue(0),
-                          MakeUintegerAccessor(&UdpServer::m_tos),
-                          MakeUintegerChecker<uint8_t>())
             .AddAttribute("PacketWindowSize",
                           "The size of the window used to compute the packet loss. This value "
                           "should be a multiple of 8.",
@@ -68,8 +57,11 @@
 }
 
 UdpServer::UdpServer()
-    : m_received(0),
-      m_lossCounter(0)
+    : SinkApplication(DEFAULT_PORT),
+      m_socket{nullptr},
+      m_socket6{nullptr},
+      m_received{0},
+      m_lossCounter{0}
 {
     NS_LOG_FUNCTION(this);
 }
@@ -114,30 +106,49 @@
 
     if (!m_socket)
     {
-        TypeId tid = TypeId::LookupByName("ns3::UdpSocketFactory");
+        auto tid = TypeId::LookupByName("ns3::UdpSocketFactory");
         m_socket = Socket::CreateSocket(GetNode(), tid);
-        InetSocketAddress local = InetSocketAddress(Ipv4Address::GetAny(), m_port);
+        auto local = m_local;
+        if (local.IsInvalid())
+        {
+            local = InetSocketAddress(Ipv4Address::GetAny(), m_port);
+            NS_LOG_INFO(this << " Binding on port " << m_port << " / " << local << ".");
+        }
+        else
+        {
+            if (InetSocketAddress::IsMatchingType(m_local))
+            {
+                const auto ipv4 = InetSocketAddress::ConvertFrom(m_local).GetIpv4();
+                NS_LOG_INFO(this << " Binding on " << ipv4 << " port " << m_port << " / " << m_local
+                                 << ".");
+            }
+            else if (Ipv6Address::IsMatchingType(m_local))
+            {
+                const auto ipv6 = Inet6SocketAddress::ConvertFrom(m_local).GetIpv6();
+                NS_LOG_INFO(this << " Binding on " << ipv6 << " port " << m_port << " / " << m_local
+                                 << ".");
+            }
+        }
         if (m_socket->Bind(local) == -1)
         {
             NS_FATAL_ERROR("Failed to bind socket");
         }
+        m_socket->SetRecvCallback(MakeCallback(&UdpServer::HandleRead, this));
     }
 
-    m_socket->SetIpTos(m_tos); // Affects only IPv4 sockets.
-    m_socket->SetRecvCallback(MakeCallback(&UdpServer::HandleRead, this));
-
-    if (!m_socket6)
+    if (m_local.IsInvalid() && !m_socket6)
     {
-        TypeId tid = TypeId::LookupByName("ns3::UdpSocketFactory");
+        // local address is not specified, so create another socket to also listen to all IPv6
+        // addresses
+        auto tid = TypeId::LookupByName("ns3::UdpSocketFactory");
         m_socket6 = Socket::CreateSocket(GetNode(), tid);
-        Inet6SocketAddress local = Inet6SocketAddress(Ipv6Address::GetAny(), m_port);
+        auto local = Inet6SocketAddress(Ipv6Address::GetAny(), m_port);
         if (m_socket6->Bind(local) == -1)
         {
             NS_FATAL_ERROR("Failed to bind socket");
         }
+        m_socket6->SetRecvCallback(MakeCallback(&UdpServer::HandleRead, this));
     }
-
-    m_socket6->SetRecvCallback(MakeCallback(&UdpServer::HandleRead, this));
 }
 
 void
@@ -149,26 +160,29 @@
     {
         m_socket->SetRecvCallback(MakeNullCallback<void, Ptr<Socket>>());
     }
+    if (m_socket6)
+    {
+        m_socket6->SetRecvCallback(MakeNullCallback<void, Ptr<Socket>>());
+    }
 }
 
 void
 UdpServer::HandleRead(Ptr<Socket> socket)
 {
     NS_LOG_FUNCTION(this << socket);
-    Ptr<Packet> packet;
     Address from;
-    Address localAddress;
-    while ((packet = socket->RecvFrom(from)))
+    while (auto packet = socket->RecvFrom(from))
     {
+        Address localAddress;
         socket->GetSockName(localAddress);
         m_rxTrace(packet);
         m_rxTraceWithAddresses(packet, from, localAddress);
         if (packet->GetSize() > 0)
         {
-            uint32_t receivedSize = packet->GetSize();
+            const auto receivedSize = packet->GetSize();
             SeqTsHeader seqTs;
             packet->RemoveHeader(seqTs);
-            uint32_t currentSequenceNumber = seqTs.GetSeq();
+            const auto currentSequenceNumber = seqTs.GetSeq();
             if (InetSocketAddress::IsMatchingType(from))
             {
                 NS_LOG_INFO("TraceDelay: RX " << receivedSize << " bytes from "
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/applications/model/udp-server.h ns-3.44/src/applications/model/udp-server.h
--- ns-3.43/src/applications/model/udp-server.h	2024-10-09 16:41:09.848655700 -0700
+++ ns-3.44/src/applications/model/udp-server.h	2025-03-09 16:55:49.347370900 -0700
@@ -12,9 +12,8 @@
 #define UDP_SERVER_H
 
 #include "packet-loss-counter.h"
+#include "sink-application.h"
 
-#include "ns3/address.h"
-#include "ns3/application.h"
 #include "ns3/event-id.h"
 #include "ns3/ptr.h"
 #include "ns3/traced-callback.h"
@@ -22,51 +21,55 @@
 namespace ns3
 {
 /**
- * \ingroup applications
- * \defgroup udpclientserver UdpClientServer
+ * @ingroup applications
+ * @defgroup udpclientserver UdpClientServer
  */
 
 /**
- * \ingroup udpclientserver
+ * @ingroup udpclientserver
  *
- * \brief A UDP server, receives UDP packets from a remote host.
+ * @brief A UDP server, receives UDP packets from a remote host.
  *
  * UDP packets carry a 32bits sequence number followed by a 64bits time
  * stamp in their payloads. The application uses the sequence number
  * to determine if a packet is lost, and the time stamp to compute the delay.
  */
-class UdpServer : public Application
+class UdpServer : public SinkApplication
 {
   public:
+    static constexpr uint16_t DEFAULT_PORT{100}; //!< default port
+
     /**
-     * \brief Get the type ID.
-     * \return the object TypeId
+     * @brief Get the type ID.
+     * @return the object TypeId
      */
     static TypeId GetTypeId();
+
     UdpServer();
     ~UdpServer() override;
+
     /**
-     * \brief Returns the number of lost packets
-     * \return the number of lost packets
+     * @brief Returns the number of lost packets
+     * @return the number of lost packets
      */
     uint32_t GetLost() const;
 
     /**
-     * \brief Returns the number of received packets
-     * \return the number of received packets
+     * @brief Returns the number of received packets
+     * @return the number of received packets
      */
     uint64_t GetReceived() const;
 
     /**
-     * \brief Returns the size of the window used for checking loss.
-     * \return the size of the window used for checking loss.
+     * @brief Returns the size of the window used for checking loss.
+     * @return the size of the window used for checking loss.
      */
     uint16_t GetPacketWindowSize() const;
 
     /**
-     * \brief Set the size of the window used for checking loss. This value should
+     * @brief Set the size of the window used for checking loss. This value should
      *  be a multiple of 8
-     * \param size the size of the window used for checking loss. This value should
+     * @param size the size of the window used for checking loss. This value should
      *  be a multiple of 8
      */
     void SetPacketWindowSize(uint16_t size);
@@ -76,18 +79,16 @@
     void StopApplication() override;
 
     /**
-     * \brief Handle a packet reception.
+     * @brief Handle a packet reception.
      *
      * This function is called by lower layers.
      *
-     * \param socket the socket the packet was received to.
+     * @param socket the socket the packet was received to.
      */
     void HandleRead(Ptr<Socket> socket);
 
-    uint16_t m_port;                 //!< Port on which we listen for incoming packets.
-    uint8_t m_tos;                   //!< The packets Type of Service
-    Ptr<Socket> m_socket;            //!< IPv4 Socket
-    Ptr<Socket> m_socket6;           //!< IPv6 Socket
+    Ptr<Socket> m_socket;            //!< Socket
+    Ptr<Socket> m_socket6;           //!< IPv6 Socket (used if only port is specified)
     uint64_t m_received;             //!< Number of received packets
     PacketLossCounter m_lossCounter; //!< Lost packet counter
 
